PF-build.sh 39 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Donnot istall 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machinename> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.0.6-Build_30
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with english only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and english only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selction GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR english only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Splitted the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Ardunio IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env gihub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards github fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modiffied checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers respository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for comming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have seperated build enviroments depening on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Audrino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multilanguage vairants it makes it easier to find missing or unused transltions.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to scrpit commits
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. # Clean PF-Firmware build when changing git branch
  133. #### Start check if OSTYPE is supported
  134. OS_FOUND=$( command -v uname)
  135. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  136. linux*)
  137. TARGET_OS="linux"
  138. ;;
  139. msys*|cygwin*|mingw*)
  140. # or possible 'bash on windows'
  141. TARGET_OS='windows'
  142. ;;
  143. nt|win*)
  144. TARGET_OS='windows'
  145. ;;
  146. *)
  147. TARGET_OS='unknown'
  148. ;;
  149. esac
  150. # Windows
  151. if [ $TARGET_OS == "windows" ]; then
  152. if [ $(uname -m) == "x86_64" ]; then
  153. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  154. Processor="64"
  155. elif [ $(uname -m) == "i386" ]; then
  156. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  157. Processor="32"
  158. else
  159. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  160. echo "Please refer to the notes of build.sh$(tput sgr0)"
  161. exit 1
  162. fi
  163. # Linux
  164. elif [ $TARGET_OS == "linux" ]; then
  165. if [ $(uname -m) == "x86_64" ]; then
  166. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  167. Processor="64"
  168. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  169. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  170. Processor="32"
  171. else
  172. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  173. echo "Please refer to the notes of build.sh$(tput sgr0)"
  174. exit 1
  175. fi
  176. else
  177. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  178. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  179. echo "Read the notes of build.sh$(tput sgr0)"
  180. exit 1
  181. fi
  182. sleep 2
  183. #### End check if OSTYPE is supported
  184. #### Prepare bash environment and check if wget, zip and other needed things are available
  185. # Check wget
  186. if ! type wget > /dev/null; then
  187. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  188. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  189. exit 2
  190. fi
  191. # Check for zip
  192. if ! type zip > /dev/null; then
  193. if [ $TARGET_OS == "windows" ]; then
  194. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  195. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  196. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  197. echo "Run git Bash under Administrator privilege and"
  198. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  199. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  200. exit 3
  201. elif [ $TARGET_OS == "linux" ]; then
  202. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  203. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  204. sudo apt-get update && apt-get install zip
  205. exit 3
  206. fi
  207. fi
  208. # Check python ... needed during language build
  209. if ! type python > /dev/null; then
  210. if [ $TARGET_OS == "windows" ]; then
  211. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  212. exit 4
  213. elif [ $TARGET_OS == "linux" ]; then
  214. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  215. echo "As Python 2.x will not be maintained from 2020 please,"
  216. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  217. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  218. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  219. sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  220. exit 4
  221. fi
  222. fi
  223. #### End prepare bash / Linux environment
  224. #### Set build environment
  225. ARDUINO_ENV="1.8.5"
  226. BUILD_ENV="1.0.6"
  227. BOARD="prusa_einsy_rambo"
  228. BOARD_PACKAGE_NAME="PrusaResearch"
  229. BOARD_VERSION="1.0.3"
  230. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/package_prusa3d_index.json"
  231. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  232. BOARD_FILENAME="prusa3dboards"
  233. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  234. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  235. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  236. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  237. LIB="PrusaLibrary"
  238. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  239. # List few useful data
  240. echo
  241. echo "Script path :" $SCRIPT_PATH
  242. echo "OS :" $OS
  243. echo "OS type :" $TARGET_OS
  244. echo ""
  245. echo "Ardunio IDE :" $ARDUINO_ENV
  246. echo "Build env :" $BUILD_ENV
  247. echo "Board :" $BOARD
  248. echo "Package name:" $BOARD_PACKAGE_NAME
  249. echo "Board v. :" $BOARD_VERSION
  250. echo "Specific Lib:" $LIB
  251. echo ""
  252. #### Start prepare building environment
  253. #Check if build exists and creates it if not
  254. if [ ! -d "../PF-build-dl" ]; then
  255. mkdir ../PF-build-dl || exit 5
  256. fi
  257. cd ../PF-build-dl || exit 6
  258. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  259. # Check if PF-build-env-<version> exists and downloads + creates it if not
  260. # The build environment is based on the supported Arduino IDE portable version with some changes
  261. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  262. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  263. mkdir ../PF-build-env-$BUILD_ENV
  264. sleep 5
  265. fi
  266. # Download and extract supported Arduino IDE depending on OS
  267. # Windows
  268. if [ $TARGET_OS == "windows" ]; then
  269. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  270. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  271. sleep 2
  272. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 7
  273. echo "$(tput sgr 0)"
  274. fi
  275. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  276. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  277. sleep 2
  278. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 7
  279. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  280. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  281. echo "$(tput sgr0)"
  282. fi
  283. fi
  284. # Linux
  285. if [ $TARGET_OS == "linux" ]; then
  286. # 32 or 64 bit version
  287. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  288. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  289. sleep 2
  290. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  291. echo "$(tput sgr 0)"
  292. fi
  293. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  294. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  295. sleep 2
  296. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  297. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  298. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  299. echo "$(tput sgr0)"
  300. fi
  301. fi
  302. # Make Arduino IDE portable
  303. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  304. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  305. fi
  306. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  307. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  308. fi
  309. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  310. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  311. fi
  312. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  313. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  314. fi
  315. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  316. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  317. fi
  318. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  319. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  320. fi
  321. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  322. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  323. fi
  324. # Change Arduino IDE preferences
  325. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  326. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  327. sleep 2
  328. echo "update.check"
  329. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  330. echo "board"
  331. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  332. echo "editor.linenumbers"
  333. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  334. echo "boardsmanager.additional.urls"
  335. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  336. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  337. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  338. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  339. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  340. echo "$(tput sgr0)"
  341. fi
  342. # Download and extract Prusa Firmware related parts
  343. # Download and extract PrusaResearchRambo board
  344. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  345. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  346. sleep 2
  347. wget $BOARD_FILE_URL || exit 9
  348. fi
  349. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  350. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  351. sleep 2
  352. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  353. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  354. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  355. fi
  356. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  357. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  358. fi
  359. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  360. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  361. fi
  362. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  363. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  364. fi
  365. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  366. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  367. echo "$(tput sgr 0)"
  368. fi
  369. # Download and extract Prusa Firmware specific library files
  370. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  371. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  372. sleep 2
  373. wget $PF_BUILD_FILE_URL || exit 11
  374. echo "$(tput sgr 0)"
  375. fi
  376. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  377. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  378. sleep 2
  379. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 12
  380. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  381. echo "$(tput sgr0)"
  382. fi
  383. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  384. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  385. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  386. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  387. sleep 2
  388. fi
  389. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  390. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  391. sleep 2
  392. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  393. sleep 2
  394. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  395. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  396. echo "$(tput sgr0)"
  397. fi
  398. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  399. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  400. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  401. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  402. sleep 2
  403. echo "$(tput sgr0)"
  404. exit 13
  405. fi
  406. #### End prepare building
  407. #### Start
  408. cd $SCRIPT_PATH
  409. # First argument defines which variant of the Prusa Firmware will be compiled
  410. if [ -z "$1" ] ; then
  411. # Select which variant of the Prusa Firmware will be compiled, like
  412. PS3="Select a variant: "
  413. while IFS= read -r -d $'\0' f; do
  414. options[i++]="$f"
  415. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  416. select opt in "${options[@]}" "All" "Quit"; do
  417. case $opt in
  418. *.h)
  419. VARIANT=$(basename "$opt" ".h")
  420. VARIANTS[i++]="$opt"
  421. break
  422. ;;
  423. "All")
  424. VARIANT="All"
  425. VARIANTS=${options[*]}
  426. break
  427. ;;
  428. "Quit")
  429. echo "You chose to stop"
  430. exit
  431. ;;
  432. *)
  433. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  434. ;;
  435. esac
  436. done
  437. else
  438. if [ -f "$SCRIPT_PATH/Firmware/variants/$1" ] ; then
  439. VARIANTS=$1
  440. else
  441. echo "$(tput setaf 1)$1 could not be found in Firmware/variants please choose a valid one$(tput setaf 2)"
  442. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  443. echo "$(tput sgr0)"
  444. exit 21
  445. fi
  446. fi
  447. #Second argument defines if it is an english only version. Known values EN_ONLY / ALL
  448. #Check default language mode
  449. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  450. if [ -z "$2" ] ; then
  451. PS3="Select a language: "
  452. echo
  453. echo "Which lang-build do you want?"
  454. select yn in "Multi languages" "English only"; do
  455. case $yn in
  456. "Multi languages")
  457. LANGUAGES="ALL"
  458. break
  459. ;;
  460. "English only")
  461. LANGUAGES="EN_ONLY"
  462. break
  463. ;;
  464. *)
  465. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  466. ;;
  467. esac
  468. done
  469. else
  470. if [[ "$2" == "ALL" || "$2" == "EN_ONLY" ]] ; then
  471. LANGUAGES=$2
  472. else
  473. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  474. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as 2nd argument!"
  475. exit 22
  476. fi
  477. fi
  478. #Check if DEV_STATUS is selected via argument 3
  479. if [ ! -z "$3" ] ; then
  480. if [[ "$3" == "GOLD" || "$3" == "RC" || "$3" == "BETA" || "$3" == "ALPHA" || "$3" == "DEVEL" || "$3" == "DEBUG" || "$3" == "UNKNOWN" ]] ; then
  481. DEV_STATUS_SELECTED=$3
  482. else
  483. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  484. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as 3rd argument!$(tput sgr0)"
  485. exit 23
  486. fi
  487. fi
  488. # check if script has been started with arguments
  489. if [ "$#" -eq "0" ] ; then
  490. OUTPUT=1
  491. else
  492. OUTPUT=0
  493. fi
  494. #echo "Output is:" $OUTPUT
  495. #Check git branch has changed
  496. if ! type git > /dev/null; then
  497. BRANCH=""
  498. CLEAN_PF_FW_BUILD=0
  499. else
  500. BRANCH=$(git branch --show-current)
  501. echo "Branch is:" $BRANCH
  502. if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
  503. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  504. echo "created PF-build.branch file"
  505. else
  506. PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
  507. echo "Previous branch was:" $PRE_BRANCH
  508. if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
  509. CLEAN_PF_FW_BUILD=1
  510. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  511. fi
  512. fi
  513. fi
  514. #Set BUILD_ENV_PATH
  515. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 24
  516. BUILD_ENV_PATH="$( pwd -P )"
  517. cd ../..
  518. #Checkif BUILD_PATH exists and if not creates it
  519. if [ ! -d "Prusa-Firmware-build" ]; then
  520. mkdir Prusa-Firmware-build || exit 25
  521. fi
  522. #Set the BUILD_PATH for Arduino IDE
  523. cd Prusa-Firmware-build || exit 26
  524. BUILD_PATH="$( pwd -P )"
  525. #Check git branch has changed
  526. if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
  527. read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
  528. rm -r *
  529. else
  530. echo "Nothing to clean up"
  531. fi
  532. for v in ${VARIANTS[*]}
  533. do
  534. VARIANT=$(basename "$v" ".h")
  535. # Find firmware version in Configuration.h file and use it to generate the hex filename
  536. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  537. # Find build version in Configuration.h file and use it to generate the hex filename
  538. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  539. # Check if the motherboard is an EINSY and if so only one hex file will generated
  540. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  541. # Check development status
  542. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  543. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  544. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  545. DEV_STATUS="RC"
  546. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  547. DEV_STATUS="ALPHA"
  548. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  549. DEV_STATUS="BETA"
  550. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  551. DEV_STATUS="DEVEL"
  552. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  553. DEV_STATUS="DEBUG"
  554. else
  555. DEV_STATUS="UNKNOWN"
  556. echo
  557. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  558. PS3="Select YES only if source code is tested and trusted: "
  559. select yn in "Yes" "No"; do
  560. case $yn in
  561. Yes)
  562. DEV_STATUS="GOLD"
  563. DEV_STATUS_SELECTED="GOLD"
  564. break
  565. ;;
  566. No)
  567. DEV_STATUS="UNKNOWN"
  568. DEV_STATUS_SELECTED="UNKNOWN"
  569. break
  570. ;;
  571. *)
  572. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  573. ;;
  574. esac
  575. done
  576. fi
  577. else
  578. DEV_STATUS=$DEV_STATUS_SELECTED
  579. fi
  580. #Prepare hex files folders
  581. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  582. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 27
  583. fi
  584. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  585. #Check if exactly the same hexfile already exists
  586. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  587. echo ""
  588. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  589. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  590. if [ $OUTPUT == "1" ] ; then
  591. read -t 10 -p "Press Enter to continue..."
  592. fi
  593. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  594. echo ""
  595. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  596. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  597. if [ $OUTPUT == "1" ] ; then
  598. read -t 10 -p "Press Enter to continue..."
  599. fi
  600. fi
  601. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  602. echo ""
  603. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  604. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  605. if [ $OUTPUT == "1" ] ; then
  606. read -t 10 -p "Press Enter to continue..."
  607. fi
  608. fi
  609. #List some useful data
  610. echo "$(tput setaf 2)$(tput setab 7) "
  611. echo "Variant :" $VARIANT
  612. echo "Firmware :" $FW
  613. echo "Build # :" $BUILD
  614. echo "Dev Check :" $DEV_CHECK
  615. echo "DEV Status :" $DEV_STATUS
  616. echo "Motherboard:" $MOTHERBOARD
  617. echo "Languages :" $LANGUAGES
  618. echo "Hex-file Folder:" $OUTPUT_FOLDER
  619. echo "$(tput sgr0)"
  620. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  621. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  622. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  623. else
  624. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  625. read -t 10 -p "Press Enter to continue..."
  626. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  627. fi
  628. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  629. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  630. # set FW_REPOSITORY
  631. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  632. #Prepare english only or multilanguage version to be build
  633. if [ $LANGUAGES == "EN_ONLY" ]; then
  634. echo " "
  635. echo "English only language firmware will be built"
  636. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  637. echo " "
  638. else
  639. echo " "
  640. echo "Multi-language firmware will be built"
  641. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  642. echo " "
  643. fi
  644. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  645. # if [ $TARGET_OS == "windows" ]; then
  646. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  647. # fi
  648. #### End of Prepare building
  649. #### Start building
  650. export ARDUINO=$BUILD_ENV_PATH
  651. #echo $BUILD_ENV_PATH
  652. #export BUILDER=$ARDUINO/arduino-builder
  653. echo
  654. #read -t 5 -p "Press Enter..."
  655. echo
  656. echo "Start to build Prusa Firmware ..."
  657. echo "Using variant $VARIANT$(tput setaf 3)"
  658. if [ $OUTPUT == "1" ] ; then
  659. sleep 2
  660. fi
  661. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  662. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  663. echo "$(tput sgr 0)"
  664. if [ $LANGUAGES == "ALL" ]; then
  665. echo "$(tput setaf 2)"
  666. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  667. echo "$(tput sgr 0)"
  668. if [ $OUTPUT == "1" ] ; then
  669. sleep 2
  670. fi
  671. cd $SCRIPT_PATH/lang
  672. echo "$(tput setaf 3)"
  673. ./config.sh || exit 31
  674. echo "$(tput sgr 0)"
  675. # Check if previous languages and firmware build exist and if so clean them up
  676. if [ -f "lang_en.tmp" ]; then
  677. echo ""
  678. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  679. if [ $OUTPUT == "1" ] ; then
  680. read -t 10 -p "Press Enter to continue..."
  681. fi
  682. echo "$(tput setaf 3)"
  683. ./lang-clean.sh
  684. echo "$(tput sgr 0)"
  685. fi
  686. if [ -f "progmem.out" ]; then
  687. echo ""
  688. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  689. if [ $OUTPUT == "1" ] ; then
  690. read -t 10 -p "Press Enter to continue..."
  691. fi
  692. echo "$(tput setaf 3)"
  693. ./fw-clean.sh
  694. echo "$(tput sgr 0)"
  695. fi
  696. # build languages
  697. echo "$(tput setaf 3)"
  698. ./lang-build.sh || exit 32
  699. # Combine compiled firmware with languages
  700. ./fw-build.sh || exit 33
  701. cp not_tran.txt not_tran_$VARIANT.txt
  702. cp not_used.txt not_used_$VARIANT.txt
  703. echo "$(tput sgr 0)"
  704. # Check if the motherboard is an EINSY and if so only one hex file will generated
  705. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  706. # If the motherboard is an EINSY just copy one hexfile
  707. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  708. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  709. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  710. else
  711. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  712. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  713. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  714. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  715. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  716. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  717. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  718. if [ $TARGET_OS == "windows" ]; then
  719. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  720. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  721. elif [ $TARGET_OS == "linux" ]; then
  722. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  723. fi
  724. fi
  725. # Cleanup after build
  726. echo "$(tput setaf 3)"
  727. ./fw-clean.sh || exit 34
  728. ./lang-clean.sh || exit 35
  729. echo "$(tput sgr 0)"
  730. else
  731. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  732. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  733. fi
  734. # Cleanup Firmware
  735. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  736. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  737. then
  738. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  739. fi
  740. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  741. then
  742. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  743. fi
  744. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  745. then
  746. rm $SCRIPT_PATH/lang/not_tran.txt
  747. fi
  748. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  749. then
  750. rm $SCRIPT_PATH/lang/not_used.txt
  751. fi
  752. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  753. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  754. echo $MULTI_LANGUAGE_CHECK
  755. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  756. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  757. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  758. if [ $OUTPUT == "1" ] ; then
  759. sleep 5
  760. fi
  761. done
  762. # Switch to hex path and list build files
  763. cd $SCRIPT_PATH
  764. cd ..
  765. echo "$(tput setaf 2) "
  766. echo " "
  767. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  768. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  769. #### End building